#include <iostream>
#include <vector>
#include <list>

using namespace std;

template<class T>
void print(const vector<T>&);

template<class T>
void print(const list<T>&);

int main() {
    
    vector<int> v;
    for(int i=0; i<10; ++i) v.push_back(i);
    print(v);
    
    vector<double> w;
    for(int i=0; i<10; ++i) w.push_back(1.+1./i);
    print(w);
    
    
    list<double> l;
    for(int i=0; i<10; ++i) l.push_back(1.+1./i);
    print(l);
    
    
    cin.get();
    
    
    return 0;
}

template<class T>
void print(const vector<T>& vec) {
     for(typename vector<T>::const_iterator iter=vec.begin(); iter!=vec.end(); ++iter)
        cout<<*iter<<'\t';
     cout<<endl;
}

template<class T>
void print(const list<T>& li) {
     for(typename list<T>::const_iterator iter=li.begin(); iter!=li.end(); ++iter)
        cout<<*iter<<'\t';
     cout<<endl;
}
