#include <iostream>

using namespace std;

// Template metaprogramozs
// Metaprogramozs: fordts sorn trtnik meg, s nem a futskor

//Osszegzo<10>::eredmeny=Osszegzo<9>::eredmeny+10,...Osszegzo<1>::eredmeny=1
template<int n> // 1+2+3+...+n=? sszeget szmolja ki
struct Osszegzo{
       enum{eredmeny=Osszegzo<n-1>::eredmeny+n};     // felsorols tpus
};

template<>
struct Osszegzo<1>{
       enum{eredmeny=1};
};

template<int n> // 1*2*3*...*n=? sszeget szmolja ki
struct Faktorialis{
       enum{eredmeny=Faktorialis<n-1>::eredmeny*n};
};

template<>
struct Faktorialis<1>{
       enum{eredmeny=1};
};

int main(){
    const int n=10;
    cout<<Osszegzo<n>::eredmeny<<endl;
    cout<<Faktorialis<n>::eredmeny<<endl;
    
    system("pause");
    return 0;
}
