#include <iostream>

using namespace std;

template<int n>
struct Elso{
       enum{ertek = n};
};


template<int n>
struct Masodik{
       enum{ertek = n*n};
};

template<int n>
struct Harmadik{
       enum{ertek = n*n*n};
};

/*
template<int n>
struct Paratlan{
       enum{ertek = (n%2)? 0 : n};
};
*/

template<int n>
struct Paratlan{
       enum{ertek = 2*n-1};
};

template<int a, template<int> class F>
struct Osszegzo{
       enum{ertek = Osszegzo<a-1,F>::ertek + F<a>::ertek};
};

template<template<int> class F>
struct Osszegzo<1,F>{
       enum{ertek = 1};
};



int main(){
    cout<<Osszegzo<4,Elso>::ertek<<endl;        // 1 + 2 + 3 + 4 =10
    cout<<Osszegzo<4,Masodik>::ertek<<endl;     // 1^2 + 2^2 + 3^2 + 4^2 =30
    cout<<Osszegzo<4,Harmadik>::ertek<<endl;    // 1^3 + 2^3 + 3^3 + 4^3 =100
    cout<<Osszegzo<4,Paratlan>::ertek<<endl;    // 1 + 3 + 5 + 7 =16
    
    
    system("pause");
    return 0;
}
