// A+B
// A+B+C
#include <iostream>
#include <ctime>

using namespace std;


// "keret" osztly vektorok sszegnek trolsra
template<class T, size_t N> 
class MyVectorSum;


template<class T, size_t N> 
class MyVector{
      private:
              T data[N];
      public:
             MyVector(){
                        for(size_t i=0; i<N; ++i)
                                   data[i] = rand()%100;
             }
             MyVector<T,N>& operator= (const MyVectorSum<T,N>& right){
                            // v3=v1+v2 kiszmolshoz
                            for(size_t i=0; i<N; ++i)
                                       data[i] = right[i];
                            return *this;
             }
             const T& operator[](size_t i) const { return data[i]; }
             void print(){
                  for(size_t i=0; i<N; ++i){
                             cout<<data[i]<<'\t';
                  }
                  cout<<endl;
             }
};


template<class T, size_t N> 
class MyVectorSum{
      const MyVector<T,N>& left;
      const MyVector<T,N>& right;
      
      public:
             MyVectorSum(const MyVector<T,N>& lft, const MyVector<T,N>& rght):
                        left(lft),right(rght){}
             T operator[](size_t i) const { return left[i]+right[i]; }
};


template<class T, size_t N> 
MyVectorSum<T,N> operator+(const MyVector<T,N>& left, const MyVector<T,N>& right)
                 { return MyVectorSum<T,N>(left, right); }


int main(){
    
    srand(time(0));
    
    MyVector<int,5> v1;
    v1.print();
    
    MyVector<int,5> v2;
    v2.print();
    
    MyVector<int,5> v3;
    v3=v1+v2;
    v3.print();
    
     MyVector<int,5> v4;
    // v4=v1+v2+v3;
    // v4.print();
    
    system("pause");
    return 0;
}
