// A+B
// A+B+C
#include <iostream>
#include <ctime>

using namespace std;


// "keret" osztly vektorok sszegnek trolsra
template<class, size_t, class,class> 
class MyVectorSum;


template<class T, size_t N>
class MyVector{
      private:
              T data[N];
      public:
             MyVector(){
                        for(size_t i=0; i<N; ++i)
                                   data[i] = rand()%100;
             }
             template<class Left, class Right>
             MyVector<T,N>& operator= (const MyVectorSum<T,N,Left,Right>& right){
                            // v3=v1+v2 kiszmolshoz
                            for(size_t i=0; i<N; ++i)
                                       data[i] = right[i];
                            return *this;
             }
             const T& operator[](size_t i) const { return data[i]; }
             void print(){
                  for(size_t i=0; i<N; ++i){
                             cout<<data[i]<<'\t';
                  }
                  cout<<endl;
             }
};


template<class T, size_t N, class Left, class Right> 
class MyVectorSum{
      const Left& left;
      const Right& right;
      
      public:
             MyVectorSum(const Left lft, const Right rght):
                        left(lft),right(rght){}
             T operator[](size_t i) const { return left[i]+right[i]; }
};


template<class T, size_t N> 
MyVectorSum<T,N,MyVector<T,N>,MyVector<T,N> > operator+(const MyVector<T,N>& left, const MyVector<T,N>& right)
                 { return MyVectorSum<T,N,MyVector<T,N>,MyVector<T,N> >(left, right); }

template<class T, size_t N, class Left, class Right>
MyVectorSum<T,N,MyVectorSum<T,N,Left,Right>,MyVector<T,N> > operator+(const MyVectorSum<T,N,Left,Right>& left, const MyVector<T,N>& right)
                 { return MyVectorSum<T,N,MyVectorSum<T,N,Left,Right>,MyVector<T,N> >(left, right); }


int main(){
    
    srand(time(0));
    
    MyVector<int,5> v1;
    v1.print();
    
    MyVector<int,5> v2;
    v2.print();
    
    MyVector<int,5> v3;
    v3=v1+v2;
    v3.print();
    
    MyVector<int,5> v4;
    v4=v1+v2+v3;
    v4.print();
    
    MyVector<int,5> v5;
    v5=v1+v2+v3+v4;
    v5.print();
    
    
    system("pause");
    return 0;
}
