#include <iostream>

using namespace std;

/* Seq:trol T:tpus R:tmb A:argumentum */

template<class Seq, class T, class R>
void apply(Seq& seq, R (T::*f)() const) {
     typename Seq::iterator iter=seq.begin();
     while(iter!=seq.end()) {
                            (*iter->*f) ();
                            ++iter;
     }
}
     
template<class Seq, class T, class R, class A>
void apply(Seq& seq, R (T::*f)(A), A a) {       //const? :o
     typename Seq::iterator iter=seq.begin();
     while(iter!=seq.end()) {
                            (*iter->*f) (a);
                            ++iter;
     }
}

template<class Seq, class T, class R, class A, class AA>
void apply(Seq& seq, R (T::*f)(A, AA) const, A a, AA aa){
     typename Seq::iterator iter=seq.begin();
     while(iter!=seq.end()) {
                            (*iter->*f) (a,aa);
                            ++iter;
     }
}
