#include <iostream>

using namespace std;

template<bool C, typename Ta, typename Tb>
class IfThenElse;

template <typename Ta, typename Tb>
class IfThenElse<true, Ta, Tb> {
    public:
    typedef Ta Result;
};

template <typename Ta, typename Tb>
class IfThenElse<false, Ta, Tb> {
    public:
    typedef Tb Result;
};
/*
template<int N, int Bal=1, int Jobb=N>
class Sqrt{
    public:
        enum {Kozep=(Bal+Jobb+1)/2};
        typedef typename IfThenElse<(N<Kozep*Kozep),
                                Sqrt<N,Bal,Kozep-1>,
                                Sqrt<N,Kozep,Jobb> >::Result Result_a;
                                
        enum {result = Result_a::result};
};*/

template<int I>
class Value{
    public:
        enum{result=I};
};

template<int N, int I=1>
class Sqrt{
    public:
        typedef typename IfThenElse<(N<I*I),
                                Value<I>,
                                Sqrt<N,I+1> >::Result Result_a;
                                
        enum {result = Result_a::result};
};
/*
template<int N>
class Sqrt<N,N>{
    public:
            enum{result=N};
};
*/

int main(){
    
    cout<<Sqrt<15>::result<<endl;
    cout<<Sqrt<42>::result<<endl;
    cout<<Sqrt<150>::result<<endl;
    
    system("pause");
    return 0;
}
