#include <iostream>

using namespace std;

template<int n>
struct Lucas{
    enum{eredmeny=Lucas<n-1>::eredmeny+Lucas<n-2>::eredmeny};
};

template<>
struct Lucas<2>{
    enum{eredmeny=3};
};

template<>
struct Lucas<1>{
    enum{eredmeny=1};
};


template<int a, int n>
struct Binom{
       enum{eredmeny=Binom<a-1,n>::eredmeny+Binom<a-1,n-1>::eredmeny};
};

template<int a>
struct Binom<a,0>{
       enum{eredmeny=1};
};

template<int a>
struct Binom<a,a>{
       enum{eredmeny=1};
};

template<int n>
struct Catalan{
    enum{eredmeny= (Binom<2*n,n>::eredmeny) / (n+1)};
};


template<int n>
struct Catalan_rec{
    enum{eredmeny= Catalan_rec<n-1>::eredmeny * (2*(2*n+1) / (n+2)) };
};

template<>
struct Catalan_rec<1>{
    enum{eredmeny=1};
};

template<int n>
void futtat(){
    enum{eredmeny= (n%3==1)? 1 : (n%3==2)? 2 : 0 };
    cout<<eredmeny<<endl;
};

int main(){
    const int n=10;
    cout<<Lucas<n>::eredmeny<<endl; //123
    cout<<Catalan<n>::eredmeny<<endl; //16796
    cout<<Catalan_rec<n>::eredmeny<<endl; //16796 
    
    futtat<n%3>(); //a maradek: 1
    futtat<191%3>(); //a maradek: 2
      
    system("pause");
    return 0;
    }
